<?php
/**
* @version $Id: j-noindex-url.php 1 2009-05-28 00:00:00Z era $
* @package j-noindex-url
* @copyright Era (C) 2008-2009 J-Web.Ru.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
*/


// no direct access
defined( '_JEXEC' ) or die( 'Restricted access' );

$mainframe->registerEvent('onPrepareContent', 'plgContentJNoIndexUrl');

/**
 * Plugin that cloaks all emails in content from spambots via Javascript.
 *
 * @param object|string An object with a "text" property or the string to be
 * cloaked.
 * @param array Additional parameters. See {@see plgEmailCloak()}.
 * @param int Optional page number. Unused. Defaults to zero.
 * @return boolean True on success.
 */
function plgContentJNoIndexUrl(&$row, &$params, $page=0) {
	if (is_object($row)) {
		return plgJNoIndexUrl($row->text, $params);
	}
	return plgJNoIndexUrl($row, $params);
}


function plgJNoIndexUrl(&$text, &$params) {
	if ((JString::strpos( $text, '</a>') === false) and (JString::strpos($text, '</A>') === false)) {
		$sm_find = 0;
	} else {
		$sm_find = 1;
	}

	if (!$sm_find) {
		return true;
	}

	if (!isset($JNoIndexMyArr) and !isset($JNoIndexNotMyArr)) {
		$plugin = & JPluginHelper::getPlugin('content', 'j-noindex-url');

		// Load plugin params info
		$bot_params = new JParameter($plugin->params);

		$href_target = $bot_params->get('href_target', "");

		$JNoIndexMyArr = array();
		$my_domain = $bot_params->get('my_domain', "");
		if (strlen($my_domain) > 0) {
			if (JString::strpos($my_domain, "\n") ) {
				$tmp_arr = split("\n", $my_domain);
				if (count($tmp_arr)) {
					foreach ($tmp_arr as $tmp) {
						if (strlen(str_replace("\r", "", trim($tmp)))) {
							$JNoIndexMyArr[] = str_replace("\r", "", trim($tmp));
						}
					}
				} 
			} else {
				$JNoIndexMyArr[] = trim($my_domain); 
			}
		}

		$JNoIndexNotMyArr = array();
		$not_my_domain = $bot_params->get('not_my_domain', "");
		if (strlen($not_my_domain) > 0) {
			if (JString::strpos($not_my_domain, "\n") ) {
				$tmp_arr = split("\n", $not_my_domain);
				if (count($tmp_arr)) {
					foreach ($tmp_arr as $tmp) {
						if (strlen(str_replace("\r", "", trim($tmp)))) {
							$JNoIndexNotMyArr[] = str_replace("\r", "", trim($tmp));
						}
					}
				} 
			} else {
				$JNoIndexNotMyArr[] = trim($not_my_domain); 
			}
		}
	}

	if ($sm_find) {
		$tmp_breake = '{tmp_blockbreak}';

		$text = str_replace('<a ', $tmp_breake.'<a ', $text);
		$text = str_replace('</a>', '</a>'.$tmp_breake, $text);

		$text = str_replace('<A ', $tmp_breake.'<a ', $text);
		$text = str_replace('</A>', '</a>'.$tmp_breake, $text);

		$tmp_blockbreak = split($tmp_breake, $text);
		$text = '';
		if (is_array($tmp_blockbreak)) {
			foreach ($tmp_blockbreak as $tmp_block) {
				if (JString::strpos(' '.$tmp_block, "<a ")) {
					// checks local links
					if (JString::strpos($tmp_block, "http://") or JString::strpos($tmp_block, "https://")) { $sm_find = 1; } else $sm_find = 0;

					$tmp_target = '';
					if ($sm_find) {
						$disable_link = 1;
						if (is_array($JNoIndexMyArr)) {
							foreach ($JNoIndexMyArr AS $my_url) {
								if (JString::strpos($tmp_block, $my_url)) {
									$disable_link = 0;
								}
							}
						}
						if (!$disable_link) {
							if (is_array($JNoIndexNotMyArr)) {
								foreach ($JNoIndexNotMyArr AS $not_my_url) {
									if (JString::strpos($tmp_block, $not_my_url)) {
										$disable_link = 1;
									}
								}
							}
						}
						if ($disable_link) {
							if (JString::strpos($tmp_block, '!vip')) {
								$disable_link = 0;
							}
						}

						if ($href_target) {
							if (!JString::strpos($tmp_block, ' target')) {
								$tmp_target = 'target="'.$href_target.'" ';
							}
						}

						if ($disable_link) {
							$tmp_block = str_replace( '<a ', '<noindex><a rel="nofollow" '.$tmp_target, $tmp_block );
							$tmp_block = str_replace( '/a>', '/a></noindex>', $tmp_block );
						} elseif ($sm_find and $tmp_target) {
							$tmp_block = str_replace( '<a ', '<a '.$tmp_target, $tmp_block );
						}
						$tmp_block = str_replace( '!vip', '', $tmp_block );
					}
				}
				$text .= $tmp_block;
			}
		}
	}

	return true;
}

?>